/**
 * @file
 * @brief XG3DNSOpenGLView.h̎LqB
 * @author akino
 */
#include "XG3DNSOpenGLView.h"

//-----------------------------------------------------------
#include <Cocoa/Cocoa.h>
#include <OpenCL/OpenCL.h>

//-----------------------------------------------------------
@interface XG3DOpenGLView : NSOpenGLView 
{
}
@end

@implementation XG3DOpenGLView

@end

//-----------------------------------------------------------
struct XG3DNSOpenGLView* XG3DNSOpenGLView_Setup(
    struct XBaseNSWindow* aWindow
    , const float aWidth 
    , const float aHeight 
    , const int aIsDoubleBuffer                                                
    )
{
    // [N΍
    NSAutoreleasePool* pool=[[NSAutoreleasePool alloc] init];
    
    // 
	NSOpenGLPixelFormatAttribute formatAttrib[]=
	{
		NSOpenGLPFAWindow,
		NSOpenGLPFADepthSize,(NSOpenGLPixelFormatAttribute)32,
		NSOpenGLPFADoubleBuffer,
		0
	};
    if ( aIsDoubleBuffer == 0 )
	{
		formatAttrib[3]=0;
	}
    
    // sNZtH[}bg
	NSOpenGLPixelFormat* format= [[[NSOpenGLPixelFormat alloc] initWithAttributes: formatAttrib] autorelease];
	
    // view쐬
	NSRect contRect = NSMakeRect( 0 , 0 , aWidth , aHeight );    
	XG3DOpenGLView* view = [[XG3DOpenGLView alloc]
     initWithFrame:contRect
     pixelFormat:format
     ];
	
    // EBhEɐݒ
    NSWindow* window = (NSWindow*)aWindow;
	[window setContentView:view];
	[window makeFirstResponder:view];
    
    // ȉ̃R[hs邱ƂglR[hg悤ɂ
	[window makeKeyAndOrderFront:nil];
	[window makeMainWindow];
    [window orderOut:nil];
    
    // ʂԂ
    [pool release];
    return (struct XG3DNSOpenGLView*)view;    
}

//-----------------------------------------------------------
void XG3DNSOpenGLView_FlushBuffer( struct XG3DNSOpenGLView* aView )
{
    NSOpenGLView* view = (NSOpenGLView*)aView;
    [[view openGLContext] flushBuffer];
}
                                                
//-----------------------------------------------------------@
// EOF
